﻿package 
{
	import flash.display.MovieClip;
	import flash.events.MouseEvent;
	import flash.events.Event;
	import flash.display.LoaderInfo;
	import flash.display.DisplayObject;
	import flash.display.Loader;
	import flash.system.LoaderContext;
	import flash.system.ApplicationDomain;
	import flash.net.URLRequest;

	public class Parent extends MovieClip
	{

		public var loader1MC:MovieClip;
		public var loader2MC:MovieClip;
		public var loader3MC:MovieClip;
		public var loader4MC:MovieClip;
		private var loadedDO:DisplayObject;
		private var as3Loader:Loader;

		public function Parent()
		{

			loader1MC.addEventListener(MouseEvent.CLICK, onToggleLoadUnload);
			loader2MC.addEventListener(MouseEvent.CLICK, onToggleLoadUnload);
			loader3MC.addEventListener(MouseEvent.CLICK, onToggleLoadUnload);
			loader4MC.addEventListener(MouseEvent.CLICK, onToggleLoadUnload);

		}

		private function onToggleLoadUnload(event:MouseEvent):void
		{
			var url:String;

			if (event.currentTarget == loader1MC)
			{
				output_txt.text = ("flashbuilder game without context var");
				url = "files/fb_minigame.swf";
			}
			else if (event.currentTarget == loader2MC)
			{
				output_txt.text = ("flashbuilder game with context var");
				url = "files/fb_minigame_context.swf";
			}
			else if (event.currentTarget == loader3MC)
			{
				output_txt.text = ("flash version without context var");
				url = "files/FLA_minigame.swf";
			}
			else
			{
				output_txt.text = ("flash version with context var");
				url = "files/FLA_minigame_context.swf";
			}
			setupLoad(url);

		}

		private function setupLoad(url:String):void
		{
			if (loadedDO)
			{
				// Unload
				loadedDO.loaderInfo.loader.unloadAndStop(true);
				this.removeChild(loadedDO);
				loadedDO = null;

			}
			else
			{
				// Load
				as3Loader = new Loader();
				var appContext:LoaderContext = new LoaderContext(false,new ApplicationDomain(null));
				as3Loader.contentLoaderInfo.addEventListener(Event.COMPLETE, onLoaderComplete);
				as3Loader.load(new URLRequest(url), appContext);

			}
		}

		private function onLoaderComplete(event:Event):void
		{

			var lInfo:LoaderInfo = event.currentTarget as LoaderInfo;
			lInfo.removeEventListener(Event.COMPLETE, onLoaderComplete);
			loadedDO = lInfo.content as DisplayObject;
			this.addChild(loadedDO);

		}

	}

}